<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.11.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>ARM compilation: Compilation from source</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
  $(function() { init_search(); });
/* @license-end */
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="Logo.png"/></td>
  <td id="projectalign">
   <div id="projectname">ARM compilation
   </div>
   <div id="projectbrief">VICODaemon and VICOLib</div>
  </td>
    <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <span id="MSearchSelect"                onmouseover="return searchBox.OnSearchSelectShow()"                onmouseout="return searchBox.OnSearchSelectHide()">&#160;</span>
          <input type="text" id="MSearchField" value="" placeholder="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.svg" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.11.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() { codefold.init(0); });
/* @license-end */
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('a00011.html',''); initResizable(true); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div><div class="header">
  <div class="headertitle"><div class="title">Compilation from source</div></div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p><a class="anchor" id="autotoc_md2"></a> </p>
<h1><a class="anchor" id="autotoc_md3"></a>
Version</h1>
<p>2.1, dated 06.12.2024</p>
<h1><a class="anchor" id="autotoc_md4"></a>
Introduction</h1>
<p>This guide describes how to compile, deploy and run</p>
<ul>
<li>VICODaemon (uses libraries <em>HIDAPI</em> and <em>QtService</em>), and</li>
<li>VICOLib</li>
</ul>
<h2><a class="anchor" id="autotoc_md5"></a>
Environment</h2>
<ul>
<li>Tested under:<ul>
<li>Compiler Device:<ul>
<li>OS: Debian 12.5 (bookworm) was released on February 10th, 2024<ul>
<li>Target Device <em>arm64</em>:<ul>
<li>Hardware: Raspberry Pi 4 Model B Rev 1.5</li>
<li>OS:<ul>
<li>Raspberry Pi OS with desktop</li>
<li>Release date: March 15th 2024</li>
<li>System: 64-bit</li>
<li>Kernel version: 6.6</li>
<li>Debian version: 12 (bookworm)</li>
<li><code>dpkg --print-architecture</code>: <code>arm64</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<h2><a class="anchor" id="autotoc_md6"></a>
Notes</h2>
<ul>
<li>Internet connection is needed to download repositories and source codes.</li>
<li>An easy to use bash script <code>VICO-src\doc\Compilation_from_source.sh</code> with all the following commands is part of the <a href="https://gitlab.com/ketek/software/VICO-src.git" title="https://gitlab.com/ketek/software/VICO-src.git">VICO-src</a> repository an can be used for cross-compilation.</li>
<li>Depending on the target directories used in this guide <em>sudo</em> rights might be necessary for some of the commands.</li>
</ul>
<h1><a class="anchor" id="autotoc_md7"></a>
Prerequisite</h1>
<p>The specific ARM architecture is needed to be added for <em>apt</em> so that <em>apt</em> would be able to install ARM-specific libraries (if needed) that can be used for cross-compilation.</p>
<p>The architectures of interest are:</p>
<ul>
<li>arm64</li>
<li>armel</li>
<li>armhf</li>
</ul>
<p>See <a href="https://www.baeldung.com/linux/arm64-armel-armhf-overview" title="https://www.baeldung.com/linux/arm64-armel-armhf-overview">this</a> for details about the architectures.</p>
<p>In order to add the specific architecture, use the following command.</p>
<div class="fragment"><div class="line"># Prerequisite</div>
<div class="line"># Update apt repositories</div>
<div class="line">apt update</div>
<div class="line"># Add architecture</div>
<div class="line">## for arm64</div>
<div class="line">dpkg --add-architecture arm64</div>
<div class="line">## for armel</div>
<div class="line">dpkg --add-architecture armel</div>
<div class="line">## for armhf</div>
<div class="line">dpkg --add-architecture armhf</div>
</div><!-- fragment --><p>After adding the architecture, the common libraries need to be installed in order to be able to perform the cross-compilation.</p>
<div class="fragment"><div class="line"># Add common libraries for cross-compilation</div>
<div class="line">apt update &amp;&amp; apt install -y pkg-config libncurses5-dev build-essential bison flex libssl-dev bc python-is-python3 python3-pip curl git cmake ninja-build</div>
</div><!-- fragment --><p>Depending on the target architecture, the cross compiler needs to be installed.</p>
<div class="fragment"><div class="line"># Install cross-compiler</div>
<div class="line">## for arm64</div>
<div class="line">apt install -y libc6-arm64-cross libc6-dev-arm64-cross binutils-aarch64-linux-gnu gcc-aarch64-linux-gnu g++-aarch64-linux-gnu</div>
<div class="line">## for armel</div>
<div class="line">apt install -y libc6-armel-cross libc6-dev-armel-cross binutils-arm-linux-gnueabi gcc-arm-linux-gnueabi g++-arm-linux-gnueabi</div>
<div class="line">## for armhf</div>
<div class="line">apt install -y libc6-armhf-cross libc6-dev-armhf-cross binutils-arm-linux-gnueabihf gcc-arm-linux-gnueabihf g++-arm-linux-gnueabihf</div>
</div><!-- fragment --><h1><a class="anchor" id="autotoc_md8"></a>
VICO-src</h1>
<h2><a class="anchor" id="autotoc_md9"></a>
VICO-src Setup</h2>
<p>The VICODaemon and VICOLib sources including toolchain files for cross compilation can be cloned from the <a href="https://gitlab.com/ketek/software/VICO-src.git" title="https://gitlab.com/ketek/software/VICO-src.git">VICO-src</a> repository.</p>
<div class="fragment"><div class="line"># VICO-src</div>
<div class="line"># Get the source files</div>
<div class="line">## for arm64</div>
<div class="line">git clone https://gitlab.com/ketek/software/VICO-src.git VICO-src_arm64</div>
<div class="line">## for armel</div>
<div class="line">git clone https://gitlab.com/ketek/software/VICO-src.git VICO-src_armel</div>
<div class="line">## for armhf</div>
<div class="line">git clone https://gitlab.com/ketek/software/VICO-src.git VICO-src_armhf</div>
</div><!-- fragment --><h1><a class="anchor" id="autotoc_md10"></a>
Qt</h1>
<h2><a class="anchor" id="autotoc_md11"></a>
Qt Setup</h2>
<p>The Qt sources need to be downloaded for compilation. The official <a href="https://download.qt.io/" title="https://download.qt.io/">Qt downloads website</a> can be used for that.</p>
<p>In our case, the <a href="https://download.qt.io/archive/qt/6.5/6.5.2/single/qt-everywhere-src-6.5.2.tar.xz.mirrorlist" title="https://download.qt.io/archive/qt/6.5/6.5.2/single/qt-everywhere-src-6.5.2.tar.xz.mirrorlist">Qt version 6.5.2</a> is to be used.</p>
<p>The sources can either be downloaded manually or curl (or a similar program) can be used.</p>
<div class="fragment"><div class="line"># Qt compilation</div>
<div class="line">## for arm64, armel and armhf</div>
<div class="line">### Choose the most suitable mirror in https://download.qt.io/archive/qt/6.5/6.5.2/single/qt-everywhere-src-6.5.2.tar.xz.mirrorlist</div>
<div class="line">curl -O https://ftp.fau.de/qtproject/archive/qt/6.5/6.5.2/single/qt-everywhere-src-6.5.2.tar.xz</div>
<div class="line">### Extract the file</div>
<div class="line">tar -xf qt-everywhere-src-6.5.2.tar.xz</div>
<div class="line">### Remove archive</div>
<div class="line">rm qt-everywhere-src-6.5.2.tar.xz</div>
<div class="line">### Go into the extracted directory</div>
<div class="line">cd qt-everywhere-src-6.5.2</div>
</div><!-- fragment --><p>Qt offers multiple of configuration for the compilations. They are located in <code>qtbase/mkspecs</code>.</p>
<p>The configurations for <em>arm64</em> and <em>armel</em> are already provided by Qt in <code>qtbase/mkspecs/linux-aarch64-gnu-g++</code> and <code>qtbase/mkspecs/linux-arm-gnueabi-g++</code> respectively.</p>
<h3><a class="anchor" id="autotoc_md12"></a>
armhf only</h3>
<p>For <em>armhf</em>, we need to create the configuration manually using the following commands.</p>
<div class="fragment"><div class="line">## for armhf only</div>
<div class="line">### Copy the directory `qtbase/mkspecs/linux-arm-gnueabi-g++` into the new armhf configuration directory `qtbase/mkspecs/linux-arm-gnueabihf-g++`</div>
<div class="line">cp -r qtbase/mkspecs/linux-arm-gnueabi-g++ qtbase/mkspecs/linux-arm-gnueabihf-g++</div>
<div class="line">### Modify the contents of the new `qtbase/mkspecs/linux-arm-gnueabihf-g++/qmake.conf` file to use the armhf cross-compiler</div>
<div class="line">sed -i -e &quot;s|arm-linux-gnueabi-|arm-linux-gnueabihf-|&quot; qtbase/mkspecs/linux-arm-gnueabihf-g++/qmake.conf</div>
<div class="line">### Change directory</div>
<div class="line">cd ..</div>
</div><!-- fragment --><h2><a class="anchor" id="autotoc_md13"></a>
Compilation</h2>
<p>The following commands are to be used in order to proceed with the compilation:</p>
<h3><a class="anchor" id="autotoc_md14"></a>
Qt compilation</h3>
<div class="fragment"><div class="line"># Qt compilation</div>
<div class="line">## for x86_64</div>
<div class="line">### Copy the extracted directory</div>
<div class="line">cp -r qt-everywhere-src-6.5.2 qt-everywhere-src-6.5.2_x86_64</div>
<div class="line">### Go into the copied directory</div>
<div class="line">cd qt-everywhere-src-6.5.2_x86_64</div>
<div class="line">### Configuration</div>
<div class="line">./configure \</div>
<div class="line">    -prefix /opt/x86_64/qt6 \</div>
<div class="line">    -skip qt3d -skip qt5compat -skip qtactiveqt -skip qtcharts -skip qtcoap -skip qtconnectivity \</div>
<div class="line">    -skip qtdatavis3d -skip qtdeclarative -skip qtdoc -skip qtgrpc -skip qthttpserver -skip qtimageformats \</div>
<div class="line">    -skip qtlanguageserver -skip qtlocation -skip qtlottie -skip qtmqtt -skip qtmultimedia \</div>
<div class="line">    -skip qtnetworkauth -skip qtopcua -skip qtpositioning -skip qtquick3d -skip qtquick3dphysics \</div>
<div class="line">    -skip qtquickeffectmaker -skip qtquicktimeline -skip qtremoteobjects -skip qtscxml -skip qtsensors \</div>
<div class="line">    -skip qtserialbus -skip qtserialport -skip qtshadertools -skip qtspeech -skip qtsvg -skip qtvirtualkeyboard \</div>
<div class="line">    -skip qtwayland -skip qtwebchannel -skip qtwebengine -skip qtwebsockets -skip qtwebview -no-gui \</div>
<div class="line">    -no-opengl -confirm-license</div>
<div class="line">### After configuration is done, make and install</div>
<div class="line">cmake --build . --parallel &amp;&amp; cmake --install .</div>
<div class="line">### Change directory</div>
<div class="line">cd ..</div>
<div class="line">### Remove Qt source</div>
<div class="line">rm -r qt-everywhere-src-6.5.2_x86_64</div>
<div class="line">## for arm64</div>
<div class="line">### Copy the extracted directory</div>
<div class="line">cp -r qt-everywhere-src-6.5.2 qt-everywhere-src-6.5.2_arm64</div>
<div class="line">### Go into the copied directory</div>
<div class="line">cd qt-everywhere-src-6.5.2_arm64</div>
<div class="line">### Configuration</div>
<div class="line">./configure -prefix /opt/aarch64-linux-gnu/qt6 -release -nomake tests -nomake examples \</div>
<div class="line">    -qt-host-path /opt/x86_64/qt6 \</div>
<div class="line">    -skip qt3d -skip qt5compat -skip qtactiveqt -skip qtcharts -skip qtcoap -skip qtconnectivity \</div>
<div class="line">    -skip qtdatavis3d -skip qtdeclarative -skip qtdoc -skip qtgrpc -skip qthttpserver -skip qtimageformats \</div>
<div class="line">    -skip qtlanguageserver -skip qtlocation -skip qtlottie -skip qtmqtt -skip qtmultimedia \</div>
<div class="line">    -skip qtnetworkauth -skip qtopcua -skip qtpositioning -skip qtquick3d -skip qtquick3dphysics \</div>
<div class="line">    -skip qtquickeffectmaker -skip qtquicktimeline -skip qtremoteobjects -skip qtscxml -skip qtsensors \</div>
<div class="line">    -skip qtserialbus -skip qtserialport -skip qtshadertools -skip qtspeech -skip qtsvg -skip qtvirtualkeyboard \</div>
<div class="line">    -skip qtwayland -skip qtwebchannel -skip qtwebengine -skip qtwebsockets -skip qtwebview -no-gui \</div>
<div class="line">    -no-opengl -confirm-license \</div>
<div class="line">    -- -DCMAKE_TOOLCHAIN_FILE=../VICO-src_arm64/deploy/toolchains/toolchain_arm64.cmake</div>
<div class="line">### After configuration is done, make and install</div>
<div class="line">cmake --build . --parallel &amp;&amp; cmake --install .</div>
<div class="line">### Change directory</div>
<div class="line">cd ..</div>
<div class="line">### Remove Qt source</div>
<div class="line">rm -r qt-everywhere-src-6.5.2_arm64</div>
<div class="line">## for armel</div>
<div class="line">### Copy the extracted directory</div>
<div class="line">cp -r qt-everywhere-src-6.5.2 qt-everywhere-src-6.5.2_armel</div>
<div class="line">### Go into the copied directory</div>
<div class="line">cd qt-everywhere-src-6.5.2_armel</div>
<div class="line">### Configuration</div>
<div class="line">./configure -prefix /opt/arm-linux-gnueabi/qt6 -release -nomake tests -nomake examples \</div>
<div class="line">    -qt-host-path /opt/x86_64/qt6 \</div>
<div class="line">    -skip qt3d -skip qt5compat -skip qtactiveqt -skip qtcharts -skip qtcoap -skip qtconnectivity \</div>
<div class="line">    -skip qtdatavis3d -skip qtdeclarative -skip qtdoc -skip qtgrpc -skip qthttpserver -skip qtimageformats \</div>
<div class="line">    -skip qtlanguageserver -skip qtlocation -skip qtlottie -skip qtmqtt -skip qtmultimedia \</div>
<div class="line">    -skip qtnetworkauth -skip qtopcua -skip qtpositioning -skip qtquick3d -skip qtquick3dphysics \</div>
<div class="line">    -skip qtquickeffectmaker -skip qtquicktimeline -skip qtremoteobjects -skip qtscxml -skip qtsensors \</div>
<div class="line">    -skip qtserialbus -skip qtserialport -skip qtshadertools -skip qtspeech -skip qtsvg -skip qtvirtualkeyboard \</div>
<div class="line">    -skip qtwayland -skip qtwebchannel -skip qtwebengine -skip qtwebsockets -skip qtwebview -no-gui \</div>
<div class="line">    -no-opengl -confirm-license \</div>
<div class="line">    -- -DCMAKE_TOOLCHAIN_FILE=../VICO-src_arm64/deploy/toolchains/toolchain_armel.cmake</div>
<div class="line">### After configuration is done, make and install</div>
<div class="line">cmake --build . --parallel &amp;&amp; cmake --install .</div>
<div class="line">### Change directory</div>
<div class="line">cd ..</div>
<div class="line">### Remove Qt source</div>
<div class="line">rm -r qt-everywhere-src-6.5.2_armel</div>
<div class="line">## for armhf</div>
<div class="line">### Copy the extracted directory</div>
<div class="line">cp -r qt-everywhere-src-6.5.2 qt-everywhere-src-6.5.2_armhf</div>
<div class="line">### Go into the copied directory</div>
<div class="line">cd qt-everywhere-src-6.5.2_armhf</div>
<div class="line">### Configuration</div>
<div class="line">./configure -prefix /opt/arm-linux-gnueabihf/qt6 -release -nomake tests -nomake examples \</div>
<div class="line">    -qt-host-path /opt/x86_64/qt6 \</div>
<div class="line">    -skip qt3d -skip qt5compat -skip qtactiveqt -skip qtcharts -skip qtcoap -skip qtconnectivity \</div>
<div class="line">    -skip qtdatavis3d -skip qtdeclarative -skip qtdoc -skip qtgrpc -skip qthttpserver -skip qtimageformats \</div>
<div class="line">    -skip qtlanguageserver -skip qtlocation -skip qtlottie -skip qtmqtt -skip qtmultimedia \</div>
<div class="line">    -skip qtnetworkauth -skip qtopcua -skip qtpositioning -skip qtquick3d -skip qtquick3dphysics \</div>
<div class="line">    -skip qtquickeffectmaker -skip qtquicktimeline -skip qtremoteobjects -skip qtscxml -skip qtsensors \</div>
<div class="line">    -skip qtserialbus -skip qtserialport -skip qtshadertools -skip qtspeech -skip qtsvg -skip qtvirtualkeyboard \</div>
<div class="line">    -skip qtwayland -skip qtwebchannel -skip qtwebengine -skip qtwebsockets -skip qtwebview -no-gui \</div>
<div class="line">    -no-opengl -confirm-license \</div>
<div class="line">    -- -DCMAKE_TOOLCHAIN_FILE=../VICO-src_arm64/deploy/toolchains/toolchain_armhf.cmake</div>
<div class="line">### After configuration is done, make and install</div>
<div class="line">cmake --build . --parallel &amp;&amp; cmake --install .</div>
<div class="line">### Change directory</div>
<div class="line">cd ..</div>
<div class="line">### Remove Qt source</div>
<div class="line">rm -r qt-everywhere-src-6.5.2_armhf</div>
</div><!-- fragment --><p>After the installation is done, Qt is installed within the specified prefix.</p>
<p>After that, the <em>qt-everywhere-src-6.5.2</em> directory is not needed anymore and can be removed.</p>
<div class="fragment"><div class="line"># Remove Qt source</div>
<div class="line">rm -r qt-everywhere-src-6.5.2</div>
</div><!-- fragment --><h1><a class="anchor" id="autotoc_md15"></a>
Qt Service</h1>
<p>After Qt has been installed, <a href="https://gitlab.com/ketek/software/qtservice" title="https://gitlab.com/ketek/software/qtservice">QtService</a> needs to be installed as this library is used by VICODaemon.</p>
<div class="fragment"><div class="line"># QtService</div>
<div class="line"># Install libsystemd-dev in order to include systemd service backend in QtService</div>
<div class="line">## for arm64</div>
<div class="line">apt install -y libsystemd-dev:arm64</div>
<div class="line">## for armel</div>
<div class="line">apt install -y libsystemd-dev:armel</div>
<div class="line">## for armhf</div>
<div class="line">apt install -y libsystemd-dev:armhf</div>
</div><!-- fragment --><p>This section ensures that the <code>pkg-config</code> utility can locate the <code>systemd</code> <code>.pc</code> files for the respective architectures during cross-compilation. This setup is particularly necessary in Docker environments, where <code>pkg-config</code> might not automatically detect the paths for cross-compiled libraries. The symbolic links and <code>PKG_CONFIG_PATH</code> exports provide explicit locations for <code>pkg-config</code> to find the required <code>.pc</code> files for each architecture.</p>
<div class="fragment"><div class="line"># Ensure pkg-config can find systemd .pc files (needed in Docker)</div>
<div class="line">## for arm64</div>
<div class="line">ln -sf /usr/lib/aarch64-linux-gnu/pkgconfig/libsystemd.pc /usr/lib/aarch64-linux-gnu/pkgconfig/systemd.pc</div>
<div class="line">export PKG_CONFIG_PATH=/usr/lib/aarch64-linux-gnu/pkgconfig:${PKG_CONFIG_PATH}</div>
<div class="line">## for armel</div>
<div class="line">ln -sf /usr/lib/arm-linux-gnueabi/pkgconfig/libsystemd.pc /usr/lib/arm-linux-gnueabi/pkgconfig/systemd.pc</div>
<div class="line">export PKG_CONFIG_PATH=/usr/lib/arm-linux-gnueabi/pkgconfig:${PKG_CONFIG_PATH}</div>
<div class="line">## for armhf</div>
<div class="line">ln -sf /usr/lib/arm-linux-gnueabihf/pkgconfig/libsystemd.pc /usr/lib/arm-linux-gnueabihf/pkgconfig/systemd.pc</div>
<div class="line">export PKG_CONFIG_PATH=/usr/lib/arm-linux-gnueabihf/pkgconfig:${PKG_CONFIG_PATH}</div>
<div class="line"># Add x86_64 paths (if needed)</div>
<div class="line">export PKG_CONFIG_PATH=/usr/lib/x86_64-linux-gnu/pkgconfig:${PKG_CONFIG_PATH}</div>
</div><!-- fragment --><p>Clone and install QtService.</p>
<div class="fragment"><div class="line"># Clone the QtService repository</div>
<div class="line">## for arm64</div>
<div class="line">git clone --depth 1 --branch master https://gitlab.com/ketek/software/qtservice.git QtService_arm64</div>
<div class="line">## for armel</div>
<div class="line">git clone --depth 1 --branch master https://gitlab.com/ketek/software/qtservice.git QtService_armel</div>
<div class="line">## for armhf</div>
<div class="line">git clone --depth 1 --branch master https://gitlab.com/ketek/software/qtservice.git QtService_armhf</div>
<div class="line"># Following the documentation located in the repository: run cmake and install QtService</div>
<div class="line">## for arm64</div>
<div class="line">cd QtService_arm64 &amp;&amp; /opt/aarch64-linux-gnu/qt6/bin/qt-cmake -S . -B . &amp;&amp; cmake --build . --parallel &amp;&amp; cmake --install . &amp;&amp; cd ..</div>
<div class="line">## for armel</div>
<div class="line">cd QtService_armel &amp;&amp; /opt/arm-linux-gnueabi/qt6/bin/qt-cmake -S . -B . &amp;&amp; cmake --build . --parallel &amp;&amp; cmake --install . &amp;&amp; cd ..</div>
<div class="line">## for armhf</div>
<div class="line">cd QtService_armhf &amp;&amp; /opt/arm-linux-gnueabihf/qt6/bin/qt-cmake -S . -B . &amp;&amp; cmake --build . --parallel &amp;&amp; cmake --install . &amp;&amp; cd ..</div>
<div class="line"># Remove QtService folder, as it is no longer needed</div>
<div class="line">## for arm64</div>
<div class="line">rm -r QtService_arm64</div>
<div class="line">## for armel</div>
<div class="line">rm -r QtService_armel</div>
<div class="line">## for armhf</div>
<div class="line">rm -r QtService_armhf</div>
</div><!-- fragment --><h1><a class="anchor" id="autotoc_md16"></a>
VICODaemon</h1>
<h2><a class="anchor" id="autotoc_md17"></a>
HIDAPI compilation</h2>
<p>VICODaemon depends on the <a href="https://github.com/libusb/hidapi" title="https://github.com/libusb/hidapi">hidapi</a> library. The library can be either installed directly from apt or compiled from source.</p>
<div class="fragment"><div class="line"># Install dependencies according to the documentation at https://github.com/libusb/hidapi/blob/master/BUILD.md#linux</div>
<div class="line">## for arm64</div>
<div class="line">apt install -y pkg-config libudev-dev:arm64 libusb-1.0-0-dev:arm64</div>
<div class="line">## for armel</div>
<div class="line">apt install -y pkg-config libudev-dev:armel libusb-1.0-0-dev:armel</div>
<div class="line">## for armhf</div>
<div class="line">apt install -y pkg-config libudev-dev:armhf libusb-1.0-0-dev:armhf</div>
<div class="line"># Build hidapi using the specific arm compiler using cmake</div>
<div class="line">## for arm64</div>
<div class="line">### Create temporary output for the hidapi build based on latest hidapi-0.14.0 tag</div>
<div class="line">mkdir hidapi_arm64 &amp;&amp; cd hidapi_arm64 &amp;&amp; git clone --depth 1 --branch hidapi-0.14.0 https://github.com/libusb/hidapi.git</div>
<div class="line"># Build and install using cmake</div>
<div class="line">PKG_CONFIG_PATH=/usr/lib/aarch64-linux-gnu/pkgconfig cmake ./hidapi -DCMAKE_C_COMPILER=aarch64-linux-gnu-gcc -DCMAKE_SYSTEM_NAME=Linux \</div>
<div class="line">    -DCMAKE_FIND_ROOT_PATH=/usr/aarch64-linux-gnu -DCMAKE_INSTALL_PREFIX=./install</div>
<div class="line">cmake --build . --target install</div>
<div class="line">cp -r ./install/lib/* /usr/lib/aarch64-linux-gnu/.</div>
<div class="line">cp -r ./install/include/* /usr/lib/aarch64-linux-gnu/include/</div>
<div class="line">### After that, the temporary folder can be removed.</div>
<div class="line">cd ..</div>
<div class="line">rm -r hidapi_arm64</div>
<div class="line">## for armel</div>
<div class="line">### Create temporary output for the hidapi build based on latest hidapi-0.14.0 tag</div>
<div class="line">mkdir hidapi_armel &amp;&amp; cd hidapi_armel &amp;&amp; git clone --depth 1 --branch hidapi-0.14.0 https://github.com/libusb/hidapi.git</div>
<div class="line"># Build and install using cmake</div>
<div class="line">PKG_CONFIG_PATH=/usr/lib/arm-linux-gnueabi/pkgconfig cmake ./hidapi -DCMAKE_C_COMPILER=arm-linux-gnueabi-gcc -DCMAKE_SYSTEM_NAME=Linux \</div>
<div class="line">    -DCMAKE_FIND_ROOT_PATH=/usr/arm-linux-gnueabi -DCMAKE_INSTALL_PREFIX=./install</div>
<div class="line">cmake --build . --target install</div>
<div class="line">cp -r ./install/lib/* /usr/lib/arm-linux-gnueabi/.</div>
<div class="line">cp -r ./install/include/* /usr/lib/arm-linux-gnueabi/include/</div>
<div class="line">### After that, the temporary folder can be removed.</div>
<div class="line">cd ..</div>
<div class="line">rm -r hidapi_armel</div>
<div class="line">## for armhf</div>
<div class="line">### Create temporary output for the hidapi build based on latest hidapi-0.14.0 tag</div>
<div class="line">mkdir hidapi_armhf &amp;&amp; cd hidapi_armhf &amp;&amp; git clone --depth 1 --branch hidapi-0.14.0 https://github.com/libusb/hidapi.git</div>
<div class="line"># Build and install using cmake</div>
<div class="line">PKG_CONFIG_PATH=/usr/lib/arm-linux-gnueabihf/pkgconfig cmake ./hidapi -DCMAKE_C_COMPILER=arm-linux-gnueabihf-gcc -DCMAKE_SYSTEM_NAME=Linux \</div>
<div class="line">    -DCMAKE_FIND_ROOT_PATH=/usr/arm-linux-gnueabihf -DCMAKE_INSTALL_PREFIX=./install</div>
<div class="line">cmake --build . --target install</div>
<div class="line">cp -r ./install/lib/* /usr/lib/arm-linux-gnueabihf/.</div>
<div class="line">cp -r ./install/include/* /usr/lib/arm-linux-gnueabihf/include/</div>
<div class="line">### After that, the temporary folder can be removed.</div>
<div class="line">cd ..</div>
<div class="line">rm -r hidapi_armhf</div>
</div><!-- fragment --><h2><a class="anchor" id="autotoc_md18"></a>
Compilation VICODaemon</h2>
<p>Go into the VICODaemon directory and start the compilation process.</p>
<div class="fragment"><div class="line"># Compile VICODaemon</div>
<div class="line">## for arm64</div>
<div class="line">### Change directory to VICODaemon</div>
<div class="line">cd VICO-src_arm64/VICODaemon</div>
<div class="line">### Compile using mkspecs</div>
<div class="line">/opt/aarch64-linux-gnu/qt6/bin/qmake -spec /opt/aarch64-linux-gnu/qt6/mkspecs/linux-aarch64-gnu-g++ &amp;&amp; make</div>
<div class="line">### Change directory</div>
<div class="line">cd ../../</div>
<div class="line">## for armel</div>
<div class="line">### Change directory to VICODaemon</div>
<div class="line">cd VICO-src_armel/VICODaemon</div>
<div class="line">### Compile</div>
<div class="line">/opt/arm-linux-gnueabi/qt6/bin/qmake -spec /opt/arm-linux-gnueabi/qt6/mkspecs/linux-arm-gnueabi-g++ &amp;&amp; make</div>
<div class="line">### Change directory</div>
<div class="line">cd ../../</div>
<div class="line">## for armhf</div>
<div class="line">### Change directory to VICODaemon</div>
<div class="line">cd VICO-src_armhf/VICODaemon</div>
<div class="line">### Compile</div>
<div class="line">/opt/arm-linux-gnueabihf/qt6/bin/qmake -spec /opt/arm-linux-gnueabihf/qt6/mkspecs/linux-arm-gnueabihf-g++ &amp;&amp; make</div>
<div class="line">### Change directory</div>
<div class="line">cd ../../</div>
</div><!-- fragment --><p>After the compilation is done, an executable VICODaemon file should be within the current directory.</p>
<h2><a class="anchor" id="autotoc_md19"></a>
Deployment VICODaemon</h2>
<p>The cloned VICO-src repository already contains a default folder/file structure that can be used to deploy the build artifacts.</p>
<div class="fragment"><div class="line"># Deployment</div>
<div class="line"># Copy the VICODaemon_arm deploy folder</div>
<div class="line">## for arm64</div>
<div class="line">cp -r VICO-src_arm64/deploy/VICODaemon_arm VICODaemon_arm64</div>
<div class="line">## for armel</div>
<div class="line">cp -r VICO-src_armel/deploy/VICODaemon_arm VICODaemon_armel</div>
<div class="line">## for armhf</div>
<div class="line">cp -r VICO-src_armhf/deploy/VICODaemon_arm VICODaemon_armhf</div>
<div class="line"># Copy the built VICODaemon into the usr/bin directory</div>
<div class="line">## for arm64</div>
<div class="line">cp VICO-src_arm64/VICODaemon/VICODaemon VICODaemon_arm64/usr/bin</div>
<div class="line">## for armel</div>
<div class="line">cp VICO-src_armel/VICODaemon/VICODaemon VICODaemon_armel/usr/bin</div>
<div class="line">## for armhf</div>
<div class="line">cp VICO-src_armhf/VICODaemon/VICODaemon VICODaemon_armhf/usr/bin</div>
<div class="line"># Copy Qt libraries into the usr/lib directory</div>
<div class="line">## for arm64</div>
<div class="line">cp /opt/aarch64-linux-gnu/qt6/lib/libQt6Service.so* VICODaemon_arm64/usr/lib/.</div>
<div class="line">cp /opt/aarch64-linux-gnu/qt6/lib/libQt6Network.so* VICODaemon_arm64/usr/lib/.</div>
<div class="line">cp /opt/aarch64-linux-gnu/qt6/lib/libQt6Core.so* VICODaemon_arm64/usr/lib/.</div>
<div class="line">cp /opt/aarch64-linux-gnu/qt6/lib/libQt6DBus.so* VICODaemon_arm64/usr/lib/.</div>
<div class="line">## for armel</div>
<div class="line">cp /opt/arm-linux-gnueabi/qt6/lib/libQt6Service.so* VICODaemon_armel/usr/lib/.</div>
<div class="line">cp /opt/arm-linux-gnueabi/qt6/lib/libQt6Network.so* VICODaemon_armel/usr/lib/.</div>
<div class="line">cp /opt/arm-linux-gnueabi/qt6/lib/libQt6Core.so* VICODaemon_armel/usr/lib/.</div>
<div class="line">cp /opt/arm-linux-gnueabi/qt6/lib/libQt6DBus.so* VICODaemon_armel/usr/lib/.</div>
<div class="line">## for armhf</div>
<div class="line">cp /opt/arm-linux-gnueabihf/qt6/lib/libQt6Service.so* VICODaemon_armhf/usr/lib/.</div>
<div class="line">cp /opt/arm-linux-gnueabihf/qt6/lib/libQt6Network.so* VICODaemon_armhf/usr/lib/.</div>
<div class="line">cp /opt/arm-linux-gnueabihf/qt6/lib/libQt6Core.so* VICODaemon_armhf/usr/lib/.</div>
<div class="line">cp /opt/arm-linux-gnueabihf/qt6/lib/libQt6DBus.so* VICODaemon_armhf/usr/lib/.</div>
<div class="line"># Copy the needed Qt plugins into the usr/plugins directory</div>
<div class="line">## for arm64</div>
<div class="line">cp -r /opt/aarch64-linux-gnu/qt6/plugins/servicebackends VICODaemon_arm64/usr/plugins/.</div>
<div class="line">## for armel</div>
<div class="line">cp -r /opt/arm-linux-gnueabi/qt6/plugins/servicebackends VICODaemon_armel/usr/plugins/.</div>
<div class="line">## for armhf</div>
<div class="line">cp -r /opt/arm-linux-gnueabihf/qt6/plugins/servicebackends VICODaemon_armhf/usr/plugins/.</div>
<div class="line"># Copy external libraries into the usr/lib directory</div>
<div class="line">## for arm64</div>
<div class="line">cp VICO-src_arm64/external-libs/LibFT4222/arm64/* VICODaemon_arm64/usr/lib/.</div>
<div class="line">cp /usr/lib/aarch64-linux-gnu/libhidapi-hidraw.so* VICODaemon_arm64/usr/lib/</div>
<div class="line">cp /usr/lib/aarch64-linux-gnu/libudev.so* VICODaemon_arm64/usr/lib/.</div>
<div class="line">## for armel</div>
<div class="line">cp VICO-src_armel/external-libs/LibFT4222/armel/* VICODaemon_armel/usr/lib/.</div>
<div class="line">cp /usr/lib/arm-linux-gnueabi/libhidapi-hidraw.so* VICODaemon_armel/usr/lib/</div>
<div class="line">cp /usr/lib/arm-linux-gnueabi/libudev.so* VICODaemon_armel/usr/lib/.</div>
<div class="line">## for armhf</div>
<div class="line">cp VICO-src_armhf/external-libs/LibFT4222/armhf/* VICODaemon_armhf/usr/lib/.</div>
<div class="line">cp /usr/lib/arm-linux-gnueabihf/libhidapi-hidraw.so* VICODaemon_armhf/usr/lib/</div>
<div class="line">cp /usr/lib/arm-linux-gnueabihf/libudev.so* VICODaemon_armhf/usr/lib/.</div>
<div class="line"># Copy translations</div>
<div class="line">## for arm64</div>
<div class="line">cp /opt/aarch64-linux-gnu/qt6/translations/qt_*.qm VICODaemon_arm64/usr/translations/.</div>
<div class="line">## for armel</div>
<div class="line">cp /opt/arm-linux-gnueabi/qt6/translations/qt_*.qm VICODaemon_armel/usr/translations/.</div>
<div class="line">## for armhf</div>
<div class="line">cp /opt/arm-linux-gnueabihf/qt6/translations/qt_*.qm VICODaemon_armhf/usr/translations/.</div>
<div class="line"># Copy license files</div>
<div class="line">## for arm64</div>
<div class="line">cp VICO-src_arm64/VICODaemon/LICENSE* VICODaemon_arm64/.</div>
<div class="line">## for armel</div>
<div class="line">cp VICO-src_armel/VICODaemon/LICENSE* VICODaemon_armel/.</div>
<div class="line">## for armhf</div>
<div class="line">cp VICO-src_armhf/VICODaemon/LICENSE* VICODaemon_armhf/.</div>
</div><!-- fragment --><h2><a class="anchor" id="autotoc_md20"></a>
Running VICODaemon</h2>
<p>Once deployed, the VICODaemon_* folder can be moved to an arm machine and <code>run.sh</code> can be executed there (as root).</p>
<div class="fragment"><div class="line">sudo chmod +x run.sh &amp;&amp; sudo chmod +x usr/bin/VICODaemon &amp;&amp; sudo ./run.sh &amp;&amp; systemctl status VICODaemon</div>
</div><!-- fragment --><p>The output should look similar to this example.</p>
<div class="fragment"><div class="line">● VICODaemon.service - VICODaemon Service</div>
<div class="line">     Loaded: loaded (/etc/systemd/system/VICODaemon.service; enabled; preset: enabled)</div>
<div class="line">     Active: active (running) since DDD YYYY-MM-DD HH:MM:SS CEST; XX ago</div>
<div class="line">       Docs: https://gitlab.com/ketek/software/qtservice</div>
<div class="line">   Main PID: 544246 (run_service.sh)</div>
<div class="line">      Tasks: 7 (limit: 8734)</div>
<div class="line">        CPU: 60ms</div>
<div class="line">     CGroup: /system.slice/VICODaemon.service</div>
<div class="line">             ├─544246 /bin/bash /home/path to VICODaemon/usr/bin/run_service.sh --backend systemd</div>
<div class="line">             └─544247 /home/path to VICODaemon/usr/bin/VICODaemon --backend systemd</div>
<div class="line"> </div>
<div class="line">MMM DD HH:MM:SS raspberrypi systemd[1]: Started VICODaemon.service - VICODaemon Service.</div>
<div class="line">MMM DD HH:MM:SS raspberrypi run_service.sh[544247]: Starting service.</div>
<div class="line">MMM DD HH:MM:SS raspberrypi VICODaemon[544247]: qt.service.plugin.systemd.backend: Activated D-BUS control service as &quot;VICODaemon.systemd-service&quot;</div>
</div><!-- fragment --><h1><a class="anchor" id="autotoc_md21"></a>
VICOLib</h1>
<h2><a class="anchor" id="autotoc_md22"></a>
Compilation VICOLib</h2>
<p>Go into the VICOLib directory and start the compilation process.</p>
<div class="fragment"><div class="line"># VICOLib</div>
<div class="line"># Compile VICOLib</div>
<div class="line">## for arm64</div>
<div class="line">### Change directory to VICOLib</div>
<div class="line">cd VICO-src_arm64/VICOLib</div>
<div class="line">### Compile</div>
<div class="line">/opt/aarch64-linux-gnu/qt6/bin/qmake -spec /opt/aarch64-linux-gnu/qt6/mkspecs/linux-aarch64-gnu-g++ &amp;&amp; make</div>
<div class="line">### Change directory</div>
<div class="line">cd ../../</div>
<div class="line">## for armel</div>
<div class="line">### Change directory to VICOLib</div>
<div class="line">cd VICO-src_armel/VICOLib</div>
<div class="line">### Compile</div>
<div class="line">/opt/arm-linux-gnueabi/qt6/bin/qmake -spec /opt/arm-linux-gnueabi/qt6/mkspecs/linux-arm-gnueabi-g++ &amp;&amp; make</div>
<div class="line">### Change directory</div>
<div class="line">cd ../../</div>
<div class="line">## for armhf</div>
<div class="line">### Change directory to VICOLib</div>
<div class="line">cd VICO-src_armhf/VICOLib</div>
<div class="line">### Compile</div>
<div class="line">/opt/arm-linux-gnueabihf/qt6/bin/qmake -spec /opt/arm-linux-gnueabihf/qt6/mkspecs/linux-arm-gnueabihf-g++ &amp;&amp; make</div>
<div class="line">### Change directory</div>
<div class="line">cd ../../</div>
</div><!-- fragment --><h2><a class="anchor" id="autotoc_md23"></a>
Deployment VICOLib</h2>
<p>After the compilation is done, the VICOLib library files (in the form of libVICOLib.so) are created within the current directory. The cloned VICO-src repository already contains a default folder/file structure that can be used to deploy the build artifacts and compile the example.</p>
<div class="fragment"><div class="line"># Deployment</div>
<div class="line"># Copy the VICOLib_arm deploy folder</div>
<div class="line">## for arm64</div>
<div class="line">cp -r VICO-src_arm64/deploy/VICOLib_arm VICOLib_arm64</div>
<div class="line">## for armel</div>
<div class="line">cp -r VICO-src_armel/deploy/VICOLib_arm VICOLib_armel</div>
<div class="line">## for armhf</div>
<div class="line">cp -r VICO-src_armhf/deploy/VICOLib_arm VICOLib_armhf</div>
</div><!-- fragment --><p>You can now add the library files to the deployment folder and the example project to get access to the VICOLib API.</p>
<div class="fragment"><div class="line"># Copy the built VICOLib into the directory and the example folder</div>
<div class="line">## for arm64</div>
<div class="line">cp VICO-src_arm64/VICOLib/libVICOLib.so* VICOLib_arm64/.</div>
<div class="line">cp VICO-src_arm64/VICOLib/libVICOLib.so* VICOLib_arm64/example/.</div>
<div class="line">## for armel</div>
<div class="line">cp VICO-src_armel/VICOLib/libVICOLib.so* VICOLib_armel/.</div>
<div class="line">cp VICO-src_armel/VICOLib/libVICOLib.so* VICOLib_armel/example/.</div>
<div class="line">## for armhf</div>
<div class="line">cp VICO-src_armhf/VICOLib/libVICOLib.so* VICOLib_armhf/.</div>
<div class="line">cp VICO-src_armhf/VICOLib/libVICOLib.so* VICOLib_armhf/example/.</div>
</div><!-- fragment --><p>Add the header files and Qt binaries to the example. Finally you can compile the example.</p>
<div class="fragment"><div class="line"># Copy header files and Qt binaries to the example directory</div>
<div class="line">## for arm64</div>
<div class="line">cp VICO-src_arm64/VICOLib/impl/*.h VICOLib_arm64/example/.</div>
<div class="line">cp VICODaemon_arm64/usr/lib/libQt6Core.so* VICOLib_arm64/example/.</div>
<div class="line">cp VICODaemon_arm64/usr/lib/libQt6Network.so* VICOLib_arm64/example/.</div>
<div class="line">## for armel</div>
<div class="line">cp VICO-src_armel/VICOLib/impl/*.h VICOLib_armel/example/.</div>
<div class="line">cp VICODaemon_armel/usr/lib/libQt6Core.so* VICOLib_armel/example/.</div>
<div class="line">cp VICODaemon_armel/usr/lib/libQt6Network.so* VICOLib_armel/example/.</div>
<div class="line">## for armhf</div>
<div class="line">cp VICO-src_armhf/VICOLib/impl/*.h VICOLib_armhf/example/.</div>
<div class="line">cp VICODaemon_armhf/usr/lib/libQt6Core.so* VICOLib_armhf/example/.</div>
<div class="line">cp VICODaemon_armhf/usr/lib/libQt6Network.so* VICOLib_armhf/example/.</div>
<div class="line"># Compile the example C++ file</div>
<div class="line">## for arm64</div>
<div class="line">### Change directory to VICOLib example</div>
<div class="line">cd VICOLib_arm64/example</div>
<div class="line">### Compile</div>
<div class="line">aarch64-linux-gnu-g++ -o VICOLib_arm64_example main.cpp -L. -lVICOLib -Wl,-rpath,.</div>
<div class="line">### Change directory</div>
<div class="line">cd ../../</div>
<div class="line">## for armel</div>
<div class="line">### Change directory to VICOLib example</div>
<div class="line">cd VICOLib_armel/example</div>
<div class="line">### Compile</div>
<div class="line">arm-linux-gnueabi-g++ -o VICOLib_armel_example main.cpp -L. -lVICOLib -Wl,-rpath,.</div>
<div class="line">### Change directory</div>
<div class="line">cd ../../</div>
<div class="line">## for armhf</div>
<div class="line">### Change directory to VICOLib example</div>
<div class="line">cd VICOLib_armhf/example</div>
<div class="line">### Compile</div>
<div class="line">arm-linux-gnueabihf-g++ -o VICOLib_armhf_example main.cpp -L. -lVICOLib -Wl,-rpath,.</div>
<div class="line">### Change directory</div>
<div class="line">cd ../../</div>
<div class="line"># Copy license files</div>
<div class="line">## for arm64</div>
<div class="line">cp VICO-src_arm64/VICOLib/LICENSE* VICOLib_arm64/.</div>
<div class="line">## for armel</div>
<div class="line">cp VICO-src_armel/VICOLib/LICENSE* VICOLib_armel/.</div>
<div class="line">## for armhf</div>
<div class="line">cp VICO-src_armhf/VICOLib/LICENSE* VICOLib_armhf/.</div>
</div><!-- fragment --><h2><a class="anchor" id="autotoc_md24"></a>
Running VICOLib example</h2>
<p>Once deployed, the VICOLib_* folder can be moved to an arm machine and the <code>VICOLib_arm*_example</code> can be executed within the example folder (as root).</p>
<div class="fragment"><div class="line"># for arm64</div>
<div class="line">sudo ./VICOLib_arm64_example</div>
<div class="line"># for armel</div>
<div class="line">sudo ./VICOLib_armel_example</div>
<div class="line"># for armhf</div>
<div class="line">sudo ./VICOLib_armhf_example</div>
</div><!-- fragment --><p>Depending on how many devices are connected via which interface, the output could look like this example.</p>
<div class="fragment"><div class="line">Successfully found 2 devices.</div>
<div class="line">Device #0 serial number: 5894A2FFFFFF connected over TCP interface with IP 192.168.0.2.</div>
<div class="line">Device #1 serial number: 5894A2FFFFFF connected over USB interface.</div>
<div class="line">Successfully initialized device with serial number 5894A2FFFFFF and IP address 192.168.0.2.</div>
</div><!-- fragment --><h1><a class="anchor" id="autotoc_md25"></a>
Archiving (optional)</h1>
<p>Finally, all data that is no longer required is removed and the compilations are packed in an archive.</p>
<div class="fragment"><div class="line"># Remove created folders</div>
<div class="line">## for arm64</div>
<div class="line">rm -r VICO-src_arm64</div>
<div class="line">## for armel</div>
<div class="line">rm -r VICO-src_armel</div>
<div class="line">## for armhf</div>
<div class="line">rm -r VICO-src_armhf</div>
<div class="line"> </div>
<div class="line"># Create 7z archive</div>
<div class="line">7z a VICOSoftware_arm -oVICOSoftware_arm.7z</div>
</div><!-- fragment --> </div></div><!-- contents -->
</div><!-- PageDoc -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.11.0 </li>
  </ul>
</div>
</body>
</html>
